Interface Setup

All Known Implementing Classes:
SetupImpl

public interface Setup
Client interface for Network Edge setup and configuration operations. Provides access to account listings, metro availability, agreement management, vendor terms, order terms, pricing information, and generic file uploads.
Author:
ianjones
  • Method Details

    • listAccounts

      List<Account> listAccounts(MetroCode metroCode)
      Lists available Accounts in the provided metro.
      Parameters:
      metroCode - the MetroCode of the accounts.
      Returns:
      List
    • listAllAccounts

      List<Account> listAllAccounts()
      Lists available Accounts in all available metros. Note that this can be a slow operation as it checks every metro and then de-dupes accounts based on accountId and then referenceId.
      Returns:
      List
    • listMetros

      PaginatedList<Metro> listMetros()
      Lists available Metros with Network Edge present.
      Returns:
      PaginatedList
    • listMetrosByRegion

      PaginatedList<Metro> listMetrosByRegion(Region region)
      Lists available Metros with Network Edge present in the specified Region.
      Parameters:
      region - the Region of the metros.
      Returns:
      PaginatedList
    • getAgreementStatus

      AgreementStatus getAgreementStatus(String accountNumber)
      Returns the Agreement Status for the provided account number.
      Parameters:
      accountNumber - the unique account identifier.
      Returns:
      String
    • createAgreement

      AgreementStatus createAgreement(String accountNumber, String termsVersionId)
      Creates an Agreement for the provided account number. The termsVersionId can be obtained from getAgreementStatus().
      Parameters:
      accountNumber - the unique account identifier.
      termsVersionId - the unique identifier of the agreement terms version.
      Returns:
      AgreementStatus
    • getVendorsTerms

      String getVendorsTerms(String vendorPackage, LicenseType licenseType)
      Returns the vendor terms for the specified vendor package and license type.
      Parameters:
      vendorPackage - the desired vendor package.
      licenseType - the desired LicenseType.
      Returns:
      String
    • getOrderTerms

      String getOrderTerms()
      Returns the order terms for Network Edge.
      Returns:
      String
    • getPricing

      Pricing getPricing(RequestBuilder.Pricing requestBuilder)
      Gets pricing information based on the parameters provided.
      Parameters:
      requestBuilder - the desired query parameters.
      Returns:
      Pricing
    • getPricing

      Pricing getPricing(String deviceUuid)
      Gets pricing information for the specified Device.
      Parameters:
      deviceUuid - the unique identifier of the Device.
      Returns:
      Pricing
    • getOrderSummary

      byte[] getOrderSummary(RequestBuilder.OrderSummary requestBuilder)
      Gets the order summary document based on the parameters provided.
      Parameters:
      requestBuilder - the desired query parameters.
      Returns:
      the order summary as a byte array.
    • uploadFile

      String uploadFile(MetroCode metroCode, String deviceTypeCode, FileProcessType processType, DeviceManagementType deviceManagementType, LicenseType licenseType, String fileContents)
      Uploads a generic file (a license file or a cloud-init / bootstrap file) and returns the unique id of the uploaded file. The returned file id can subsequently be referenced when creating a device or triggering an RMA (e.g. as cloudInitFileId or licenseFileId).
      Parameters:
      metroCode - the MetroCode the file applies to.
      deviceTypeCode - the device type code the file applies to (e.g. C8000V).
      processType - whether the file is a LICENSE or CLOUD_INIT file.
      deviceManagementType - the DeviceManagementType, or null.
      licenseType - the LicenseType, or null.
      fileContents - the contents of the file to upload.
      Returns:
      String the unique id of the uploaded file.
    • listDowntimeNotifications

      DowntimeNotification listDowntimeNotifications()
      Returns the current planned and unplanned downtime notifications for Network Edge APIs and infrastructure.
      Returns:
      DowntimeNotification